Index: uspace/lib/net/generic/net_checksum.c
===================================================================
--- uspace/lib/net/generic/net_checksum.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/net/generic/net_checksum.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -45,4 +45,7 @@
 #define CRC_DIVIDER_LE  0xedb88320
 
+/** Polynomial used in multicast address hashing */
+#define CRC_MCAST_POLYNOMIAL  0x04c11db6
+
 /** Compacts the computed checksum to the 16 bit number adding the carries.
  *
@@ -221,4 +224,39 @@
 }
 
+/** Compute the standard hash from MAC
+ *
+ * Hashing MAC into 64 possible values and using the value as index to
+ * 64bit number.
+ *
+ * The code is copied from qemu-0.13's implementation of ne2000 and rt8139
+ * drivers, but according to documentation there it originates in FreeBSD.
+ *
+ * @param[in] addr The 6-byte MAC address to be hashed
+ *
+ * @return 64-bit number with only single bit set to 1
+ *
+ */
+uint64_t multicast_hash(const uint8_t addr[6])
+{
+	uint32_t crc;
+    int carry, i, j;
+    uint8_t b;
+
+    crc = 0xffffffff;
+    for (i = 0; i < 6; i++) {
+        b = addr[i];
+        for (j = 0; j < 8; j++) {
+            carry = ((crc & 0x80000000L) ? 1 : 0) ^ (b & 0x01);
+            crc <<= 1;
+            b >>= 1;
+            if (carry)
+                crc = ((crc ^ CRC_MCAST_POLYNOMIAL) | carry);
+        }
+    }
+	
+    uint64_t one64 = 1;
+    return one64 << (crc >> 26);
+}
+
 /** @}
  */
Index: uspace/lib/net/generic/net_remote.c
===================================================================
--- uspace/lib/net/generic/net_remote.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/net/generic/net_remote.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -167,4 +167,13 @@
 }
 
+int net_driver_ready(async_sess_t *sess, devman_handle_t handle)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	int rc = async_req_1_0(exch, NET_NET_DRIVER_READY, handle);
+	async_exchange_end(exch);
+	
+	return rc;
+}
+
 /** @}
  */
Index: uspace/lib/net/include/net_checksum.h
===================================================================
--- uspace/lib/net/include/net_checksum.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/net/include/net_checksum.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -67,4 +67,5 @@
 extern uint16_t flip_checksum(uint16_t);
 extern uint16_t ip_checksum(uint8_t *, size_t);
+extern uint64_t multicast_hash(const uint8_t addr[6]);
 
 #endif
Index: uspace/lib/net/include/net_interface.h
===================================================================
--- uspace/lib/net/include/net_interface.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/net/include/net_interface.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -52,4 +52,5 @@
 extern int net_get_devices_req(async_sess_t *, measured_string_t **, size_t *,
     uint8_t **);
+extern int net_driver_ready(async_sess_t *, devman_handle_t);
 extern async_sess_t *net_connect_module(void);
 
Index: uspace/lib/net/include/nil_remote.h
===================================================================
--- uspace/lib/net/include/nil_remote.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/net/include/nil_remote.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -34,5 +34,4 @@
 #define __NET_NIL_REMOTE_H__
 
-#include <ipc/loc.h>
 #include <net/device.h>
 #include <net/packet.h>
@@ -40,5 +39,4 @@
 #include <generic.h>
 #include <async.h>
-#include <sys/types.h>
 
 #define nil_bind_service(service, device_id, me, receiver) \
@@ -62,4 +60,8 @@
 extern int nil_device_req(async_sess_t *, nic_device_id_t, devman_handle_t,
     size_t);
+extern int nil_device_state_msg(async_sess_t *, nic_device_id_t, sysarg_t);
+extern int nil_received_msg(async_sess_t *, nic_device_id_t, packet_id_t);
+extern int nil_addr_changed_msg(async_sess_t *, nic_device_id_t,
+    const nic_address_t *);
 
 #endif
Index: uspace/lib/net/nil/nil_remote.c
===================================================================
--- uspace/lib/net/nil/nil_remote.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/net/nil/nil_remote.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -36,5 +36,4 @@
  */
 
-#include <ipc/loc.h>
 #include <nil_remote.h>
 #include <generic.h>
@@ -44,10 +43,75 @@
 #include <ipc/nil.h>
 
+/** Notify the network interface layer about the device state change.
+ *
+ * @param[in] sess      Network interface layer session.
+ * @param[in] device_id Device identifier.
+ * @param[in] state     New device state.
+ *
+ * @return EOK on success.
+ * @return Other error codes as defined for each specific module
+ *         device state function.
+ *
+ */
+int nil_device_state_msg(async_sess_t *sess, nic_device_id_t device_id,
+    sysarg_t state)
+{
+	return generic_device_state_msg_remote(sess, NET_NIL_DEVICE_STATE,
+	    device_id, state, 0);
+}
+
+/** Pass the packet queue to the network interface layer.
+ *
+ * Process and redistribute the received packet queue to the registered
+ * upper layers.
+ *
+ * @param[in] sess      Network interface layer session.
+ * @param[in] device_id Source device identifier.
+ * @param[in] packet    Received packet or the received packet queue.
+ * @param[in] target    Target service. Ignored parameter.
+ *
+ * @return EOK on success.
+ * @return Other error codes as defined for each specific module
+ *         received function.
+ *
+ */
+int nil_received_msg(async_sess_t *sess, nic_device_id_t device_id,
+    packet_id_t packet_id)
+{
+	return generic_received_msg_remote(sess, NET_NIL_RECEIVED,
+	    device_id, packet_id, 0, 0);
+}
+
+/** Notify upper layers that device address has changed
+ *
+ */
+int nil_addr_changed_msg(async_sess_t *sess, nic_device_id_t device_id,
+    const nic_address_t *address)
+{
+	assert(sess);
+	
+	async_exch_t *exch = async_exchange_begin(sess);
+	
+	aid_t message_id = async_send_1(exch, NET_NIL_ADDR_CHANGED,
+	    (sysarg_t) device_id, NULL);
+	int rc = async_data_write_start(exch, address, sizeof (nic_address_t));
+	
+	async_exchange_end(exch);
+	
+	sysarg_t res;
+    async_wait_for(message_id, &res);
+	
+    if (rc != EOK)
+		return rc;
+	
+    return (int) res;
+}
+
 int nil_device_req(async_sess_t *sess, nic_device_id_t device_id,
-    service_id_t sid, size_t mtu)
+    devman_handle_t handle, size_t mtu)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
 	int rc = async_req_3_0(exch, NET_NIL_DEVICE, (sysarg_t) device_id,
-	    (sysarg_t) sid, (sysarg_t) mtu);
+	    (sysarg_t) handle, (sysarg_t) mtu);
 	async_exchange_end(exch);
 	return rc;
Index: uspace/lib/nic/Makefile
===================================================================
--- uspace/lib/nic/Makefile	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/nic/Makefile	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -29,9 +29,9 @@
 USPACE_PREFIX = ../..
 LIBRARY = libnic
-EXTRA_CFLAGS += -DLIBNIC_INTERNAL -Iinclude -I$(LIBDRV_PREFIX)/include
+LIBS = $(LIBDRV_PREFIX)/libdrv.a $(LIBNET_PREFIX)/libnet.a
+EXTRA_CFLAGS += -DLIBNIC_INTERNAL -Iinclude -I$(LIBDRV_PREFIX)/include -I$(LIBNET_PREFIX)/include
 
 SOURCES = \
 	src/nic_driver.c \
-	src/nic_ev.c \
 	src/nic_addr_db.c \
 	src/nic_rx_control.c \
Index: uspace/lib/nic/include/nic.h
===================================================================
--- uspace/lib/nic/include/nic.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/nic/include/nic.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -42,7 +42,6 @@
 #include <ddf/driver.h>
 #include <device/hw_res_parsed.h>
+#include <net/packet.h>
 #include <ops/nic.h>
-
-#define DEVICE_CATEGORY_NIC "nic"
 
 struct nic;
@@ -62,10 +61,9 @@
 
 /**
- * Simple structure for sending lists of frames.
+ * Simple structure for sending the allocated frames (packets) in a list.
  */
 typedef struct {
 	link_t link;
-	void *data;
-	size_t size;
+	packet_t *packet;
 } nic_frame_t;
 
@@ -73,6 +71,6 @@
 
 /**
- * Handler for writing frame data to the NIC device.
- * The function is responsible for releasing the frame.
+ * Handler for writing packet data to the NIC device.
+ * The function is responsible for releasing the packet.
  * It does not return anything, if some error is detected the function just
  * silently fails (logging on debug level is suggested).
@@ -160,5 +158,5 @@
  * @return ENOTSUP	If this filter cannot work on this NIC (e.g. the NIC
  * 					cannot run in promiscuous node or the limit of WOL
- * 					frames' specifications was reached).
+ * 					packets' specifications was reached).
  * @return ELIMIT	If this filter must implemented in HW but currently the
  * 					limit of these HW filters was reached.
@@ -206,4 +204,5 @@
 /* Functions called in add_device */
 extern int nic_connect_to_services(nic_t *);
+extern int nic_register_as_ddf_fun(nic_t *, ddf_dev_ops_t *);
 extern int nic_get_resources(nic_t *, hw_res_list_parsed_t *);
 extern void nic_set_specific(nic_t *, void *);
@@ -220,8 +219,10 @@
 	poll_mode_change_handler, poll_request_handler);
 
+/* Functions called in device_added */
+extern int nic_ready(nic_t *);
+
 /* General driver functions */
 extern ddf_dev_t *nic_get_ddf_dev(nic_t *);
 extern ddf_fun_t *nic_get_ddf_fun(nic_t *);
-extern void nic_set_ddf_fun(nic_t *, ddf_fun_t *);
 extern nic_t *nic_get_from_ddf_dev(ddf_dev_t *);
 extern nic_t *nic_get_from_ddf_fun(ddf_fun_t *);
@@ -232,5 +233,6 @@
 extern int nic_report_poll_mode(nic_t *, nic_poll_mode_t, struct timeval *);
 extern void nic_query_address(nic_t *, nic_address_t *);
-extern void nic_received_noneth_frame(nic_t *, void *, size_t);
+extern void nic_received_packet(nic_t *, packet_t *);
+extern void nic_received_noneth_packet(nic_t *, packet_t *);
 extern void nic_received_frame(nic_t *, nic_frame_t *);
 extern void nic_received_frame_list(nic_t *, nic_frame_list_t *);
@@ -246,5 +248,7 @@
 extern void nic_report_collisions(nic_t *, unsigned);
 
-/* Frame / frame list allocation and deallocation */
+/* Packet / frame / frame list allocation and deallocation */
+extern packet_t *nic_alloc_packet(nic_t *, size_t);
+extern void nic_release_packet(nic_t *, packet_t *);
 extern nic_frame_t *nic_alloc_frame(nic_t *, size_t);
 extern nic_frame_list_t *nic_alloc_frame_list(void);
@@ -271,4 +275,8 @@
 extern void nic_sw_period_stop(nic_t *);
 
+/* Packet DMA lock */
+extern int nic_dma_lock_packet(packet_t *, size_t, void **);
+extern int nic_dma_unlock_packet(packet_t *, size_t);
+
 #endif // __NIC_H__
 
Index: uspace/lib/nic/include/nic_driver.h
===================================================================
--- uspace/lib/nic/include/nic_driver.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/nic/include/nic_driver.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -44,5 +44,5 @@
 
 #include <fibril_synch.h>
-#include <nic/nic.h>
+#include <net/device.h>
 #include <async.h>
 
@@ -50,4 +50,6 @@
 #include "nic_rx_control.h"
 #include "nic_wol_virtues.h"
+
+#define DEVICE_CATEGORY_NIC "nic"
 
 struct sw_poll_info {
@@ -70,4 +72,6 @@
 	 */
 	ddf_fun_t *fun;
+	/** Identifier for higher network stack layers */
+	nic_device_id_t device_id;
 	/** Current state of the device */
 	nic_device_state_t state;
@@ -78,6 +82,8 @@
 	/** Device's default MAC address (assigned the first time, used in STOP) */
 	nic_address_t default_mac;
-	/** Client callback session */
-	async_sess_t *client_session;
+	/** Session to SERVICE_NETWORKING */
+	async_sess_t *net_session;
+	/** Session to SERVICE_ETHERNET or SERVICE_NILDUMMY */
+	async_sess_t *nil_session;
 	/** Phone to APIC or i8259 */
 	async_sess_t *irc_session;
Index: uspace/lib/nic/include/nic_impl.h
===================================================================
--- uspace/lib/nic/include/nic_impl.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/nic/include/nic_impl.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -40,6 +40,7 @@
 
 #include <assert.h>
-#include <nic/nic.h>
+#include <net/device.h>
 #include <ddf/driver.h>
+#include <nil_remote.h>
 
 /* Inclusion of this file is not prohibited, because drivers could want to
@@ -48,5 +49,6 @@
 extern int nic_get_address_impl(ddf_fun_t *dev_fun, nic_address_t *address);
 extern int nic_send_frame_impl(ddf_fun_t *dev_fun, void *data, size_t size);
-extern int nic_callback_create_impl(ddf_fun_t *dev_fun);
+extern int nic_connect_to_nil_impl(ddf_fun_t *dev_fun, services_t nil_service,
+	int device_id);
 extern int nic_get_state_impl(ddf_fun_t *dev_fun, nic_device_state_t *state);
 extern int nic_set_state_impl(ddf_fun_t *dev_fun, nic_device_state_t state);
Index: uspace/lib/nic/include/nic_rx_control.h
===================================================================
--- uspace/lib/nic/include/nic_rx_control.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/nic/include/nic_rx_control.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -45,5 +45,6 @@
 #include <adt/hash_table.h>
 #include <fibril_synch.h>
-#include <nic/nic.h>
+#include <net/device.h>
+#include <net/packet_header.h>
 
 #include "nic_addr_db.h"
@@ -119,5 +120,5 @@
 	const nic_address_t *prev_addr, const nic_address_t *curr_addr);
 extern int nic_rxc_check(const nic_rxc_t *rxc,
-	const void *data, size_t size, nic_frame_type_t *frame_type);
+	const packet_t *packet, nic_frame_type_t *frame_type);
 extern void nic_rxc_hw_filtering(nic_rxc_t *rxc,
 	int unicast_exact, int multicast_exact, int vlan_exact);
Index: uspace/lib/nic/include/nic_wol_virtues.h
===================================================================
--- uspace/lib/nic/include/nic_wol_virtues.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/nic/include/nic_wol_virtues.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -43,5 +43,5 @@
 #endif
 
-#include <nic/nic.h>
+#include <net/device.h>
 #include <adt/hash_table.h>
 #include "nic.h"
Index: uspace/lib/nic/src/nic_driver.c
===================================================================
--- uspace/lib/nic/src/nic_driver.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/nic/src/nic_driver.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -49,9 +49,12 @@
 #include <devman.h>
 #include <ddf/interrupt.h>
+#include <net_interface.h>
 #include <ops/nic.h>
+#include <packet_client.h>
+#include <packet_remote.h>
+#include <net/packet_header.h>
 #include <errno.h>
 
 #include "nic_driver.h"
-#include "nic_ev.h"
 #include "nic_impl.h"
 
@@ -61,5 +64,5 @@
 
 /**
- * Initializes libraries required for NIC framework - logger
+ * Initializes libraries required for NIC framework - logger, packet manager
  *
  * @param name	Name of the device/driver (used in logging)
@@ -76,5 +79,6 @@
 	snprintf(buffer, 256, "drv/" DEVICE_CATEGORY_NIC "/%s", name);
 	
-	return EOK;
+	/* Initialize packet manager */
+	return pm_init();
 }
 
@@ -89,4 +93,9 @@
     nic_iface_t *iface)
 {
+	if (driver_ops) {
+		if (!driver_ops->device_added)
+			driver_ops->device_added = nic_device_added_impl;
+	}
+
 	if (dev_ops) {
 		if (!dev_ops->open)
@@ -107,6 +116,6 @@
 		if (!iface->send_frame)
 			iface->send_frame = nic_send_frame_impl;
-		if (!iface->callback_create)
-			iface->callback_create = nic_callback_create_impl;
+		if (!iface->connect_to_nil)
+			iface->connect_to_nil = nic_connect_to_nil_impl;
 		if (!iface->get_address)
 			iface->get_address = nic_get_address_impl;
@@ -153,5 +162,5 @@
 
 /**
- * Setup send frame handler. This MUST be called in the add_device handler
+ * Setup write packet handler. This MUST be called in the add_device handler
  * if the nic_send_message_impl function is used for sending messages (filled
  * as send_message member of the nic_iface_t structure). The function must not
@@ -261,11 +270,29 @@
 }
 
-/** Allocate frame
+/**
+ * Just a wrapper over the packet_get_1_remote function
+ */
+packet_t *nic_alloc_packet(nic_t *nic_data, size_t data_size)
+{
+	return packet_get_1_remote(nic_data->net_session, data_size);
+}
+
+
+/**
+ * Just a wrapper over the pq_release_remote function
+ */
+void nic_release_packet(nic_t *nic_data, packet_t *packet)
+{
+	pq_release_remote(nic_data->net_session, packet_get_id(packet));
+}
+
+/** Allocate frame and packet
  *
  *  @param nic_data 	The NIC driver data
- *  @param size	        Frame size in bytes
+ *  @param packet_size	Size of packet
+ *  @param offload_size	Size of packet offload
  *  @return pointer to allocated frame if success, NULL otherwise
  */
-nic_frame_t *nic_alloc_frame(nic_t *nic_data, size_t size)
+nic_frame_t *nic_alloc_frame(nic_t *nic_data, size_t packet_size)
 {
 	nic_frame_t *frame;
@@ -286,11 +313,11 @@
 	}
 
-	frame->data = malloc(size);
-	if (frame->data == NULL) {
+	packet_t *packet = nic_alloc_packet(nic_data, packet_size);
+	if (!packet) {
 		free(frame);
 		return NULL;
 	}
 
-	frame->size = size;
+	frame->packet = packet;
 	return frame;
 }
@@ -305,11 +332,7 @@
 	if (!frame)
 		return;
-
-	if (frame->data != NULL) {
-		free(frame->data);
-		frame->data = NULL;
-		frame->size = 0;
-	}
-
+	if (frame->packet != NULL) {
+		nic_release_packet(nic_data, frame->packet);
+	}
 	fibril_mutex_lock(&nic_globals.lock);
 	if (nic_globals.frame_cache_size >= NIC_GLOBALS_MAX_CACHE_SIZE) {
@@ -424,5 +447,5 @@
 
 /**
- * Connect to IRC service. This function should be called only from
+ * Connect to the NET and IRQ services. This function should be called only from
  * the add_device handler, thus no locking is required.
  *
@@ -431,8 +454,14 @@
  * @return EOK		If connection was successful.
  * @return EINVAL	If the IRC service cannot be determined.
- * @return EREFUSED	If IRC service cannot be connected.
+ * @return EREFUSED	If NET or IRC service cannot be connected.
  */
 int nic_connect_to_services(nic_t *nic_data)
 {
+	/* NET service */
+	nic_data->net_session = service_connect_blocking(EXCHANGE_SERIALIZE,
+		SERVICE_NETWORKING, 0, 0);
+	if (nic_data->net_session == NULL)
+		return errno;
+	
 	/* IRC service */
 	sysarg_t apic;
@@ -451,4 +480,26 @@
 	
 	return EOK;
+}
+
+/** Notify the NET service that the device is ready
+ *
+ * @param nic NICF structure
+ *
+ * @return EOK on success
+ *
+ */
+int nic_ready(nic_t *nic)
+{
+	fibril_rwlock_read_lock(&nic->main_lock);
+	
+	async_sess_t *session = nic->net_session;
+	devman_handle_t handle = nic->dev->handle;
+	
+	fibril_rwlock_read_unlock(&nic->main_lock);
+	
+	if (session == NULL)
+		return EINVAL;
+	
+	return net_driver_ready(session, handle);
 }
 
@@ -495,7 +546,7 @@
 	
 	/* Notify NIL layer (and uppper) if bound - not in add_device */
-	if (nic_data->client_session != NULL) {
-		int rc = nic_ev_addr_changed(nic_data->client_session,
-		    address);
+	if (nic_data->nil_session != NULL) {
+		int rc = nil_addr_changed_msg(nic_data->nil_session,
+		    nic_data->device_id, address);
 		if (rc != EOK) {
 			fibril_rwlock_write_unlock(&nic_data->main_lock);
@@ -553,5 +604,5 @@
 
 /**
- * The busy flag can be set to 1 only in the send_frame handler, to 0 it can
+ * The busy flag can be set to 1 only in the write_packet handler, to 0 it can
  * be set anywhere.
  *
@@ -562,5 +613,5 @@
 {
 	/*
-	 * When the function is called in send_frame handler the main lock is
+	 * When the function is called in write_packet handler the main lock is
 	 * locked so no race can happen.
 	 * Otherwise, when it is unexpectedly set to 0 (even with main lock held
@@ -571,26 +622,42 @@
 
 /**
- * This is the function that the driver should call when it receives a frame.
- * The frame is checked by filters and then sent up to the NIL layer or
- * discarded. The frame is released.
- *
- * @param nic_data
- * @param frame		The received frame
+ * Provided for correct naming conventions.
+ * The packet is checked by filters and then sent up to the NIL layer or
+ * discarded, the frame is released.
+ *
+ * @param nic_data
+ * @param frame		The frame containing received packet
  */
 void nic_received_frame(nic_t *nic_data, nic_frame_t *frame)
 {
+	nic_received_packet(nic_data, frame->packet);
+	frame->packet = NULL;
+	nic_release_frame(nic_data, frame);
+}
+
+/**
+ * This is the function that the driver should call when it receives a packet.
+ * The packet is checked by filters and then sent up to the NIL layer or
+ * discarded.
+ *
+ * @param nic_data
+ * @param packet		The received packet
+ */
+void nic_received_packet(nic_t *nic_data, packet_t *packet)
+{
 	/* Note: this function must not lock main lock, because loopback driver
-	 * 		 calls it inside send_frame handler (with locked main lock) */
+	 * 		 calls it inside write_packet handler (with locked main lock) */
+	packet_id_t pid = packet_get_id(packet);
+	
 	fibril_rwlock_read_lock(&nic_data->rxc_lock);
 	nic_frame_type_t frame_type;
-	int check = nic_rxc_check(&nic_data->rx_control, frame->data,
-	    frame->size, &frame_type);
+	int check = nic_rxc_check(&nic_data->rx_control, packet, &frame_type);
 	fibril_rwlock_read_unlock(&nic_data->rxc_lock);
 	/* Update statistics */
 	fibril_rwlock_write_lock(&nic_data->stats_lock);
-
+	/* Both sending message up and releasing packet are atomic IPC calls */
 	if (nic_data->state == NIC_STATE_ACTIVE && check) {
 		nic_data->stats.receive_packets++;
-		nic_data->stats.receive_bytes += frame->size;
+		nic_data->stats.receive_bytes += packet_get_data_length(packet);
 		switch (frame_type) {
 		case NIC_FRAME_MULTICAST:
@@ -604,6 +671,5 @@
 		}
 		fibril_rwlock_write_unlock(&nic_data->stats_lock);
-		nic_ev_received(nic_data->client_session, frame->data,
-		    frame->size);
+		nil_received_msg(nic_data->nil_session, nic_data->device_id, pid);
 	} else {
 		switch (frame_type) {
@@ -619,31 +685,31 @@
 		}
 		fibril_rwlock_write_unlock(&nic_data->stats_lock);
-	}
-	nic_release_frame(nic_data, frame);
+		nic_release_packet(nic_data, packet);
+	}
 }
 
 /**
  * This function is to be used only in the loopback driver. It's workaround
- * for the situation when the frame does not contain ethernet address.
+ * for the situation when the packet does not contain ethernet address.
  * The filtering is therefore not applied here.
  *
  * @param nic_data
- * @param data		Frame data
- * @param size		Frame size in bytes
- */
-void nic_received_noneth_frame(nic_t *nic_data, void *data, size_t size)
+ * @param packet
+ */
+void nic_received_noneth_packet(nic_t *nic_data, packet_t *packet)
 {
 	fibril_rwlock_write_lock(&nic_data->stats_lock);
 	nic_data->stats.receive_packets++;
-	nic_data->stats.receive_bytes += size;
+	nic_data->stats.receive_bytes += packet_get_data_length(packet);
 	fibril_rwlock_write_unlock(&nic_data->stats_lock);
 	
-	nic_ev_received(nic_data->client_session, data, size);
-}
-
-/**
- * Some NICs can receive multiple frames during single interrupt. These can
+	nil_received_msg(nic_data->nil_session, nic_data->device_id,
+	    packet_get_id(packet));
+}
+
+/**
+ * Some NICs can receive multiple packets during single interrupt. These can
  * send them in whole list of frames (actually nic_frame_t structures), then
- * the list is deallocated and each frame is passed to the
+ * the list is deallocated and each packet is passed to the
  * nic_received_packet function.
  *
@@ -660,5 +726,7 @@
 
 		list_remove(&frame->link);
-		nic_received_frame(nic_data, frame);
+		nic_received_packet(nic_data, frame->packet);
+		frame->packet = NULL;
+		nic_release_frame(nic_data, frame);
 	}
 	nic_driver_release_frame_list(frames);
@@ -690,6 +758,8 @@
 	nic_data->dev = NULL;
 	nic_data->fun = NULL;
+	nic_data->device_id = NIC_DEVICE_INVALID_ID;
 	nic_data->state = NIC_STATE_STOPPED;
-	nic_data->client_session = NULL;
+	nic_data->net_session = NULL;
+	nic_data->nil_session = NULL;
 	nic_data->irc_session = NULL;
 	nic_data->poll_mode = NIC_POLL_IMMEDIATE;
@@ -745,6 +815,10 @@
  */
 static void nic_destroy(nic_t *nic_data) {
-	if (nic_data->client_session != NULL) {
-		async_hangup(nic_data->client_session);
+	if (nic_data->net_session != NULL) {
+		async_hangup(nic_data->net_session);
+	}
+
+	if (nic_data->nil_session != NULL) {
+		async_hangup(nic_data->nil_session);
 	}
 
@@ -772,4 +846,41 @@
 
 /**
+ * Creates an exposed DDF function for the device, named "port0".
+ * Device options are set as this function's options. The function is bound
+ * (see ddf_fun_bind) and then registered to the DEVICE_CATEGORY_NIC class.
+ * Note: this function should be called only from add_device handler, therefore
+ * we don't need to use locks.
+ *
+ * @param nic_data	The NIC structure
+ * @param ops		Device options for the DDF function.
+ */
+int nic_register_as_ddf_fun(nic_t *nic_data, ddf_dev_ops_t *ops)
+{
+	int rc;
+	assert(nic_data);
+
+	nic_data->fun = ddf_fun_create(nic_data->dev, fun_exposed, "port0");
+	if (nic_data->fun == NULL)
+		return ENOMEM;
+	
+	nic_data->fun->ops = ops;
+	nic_data->fun->driver_data = nic_data;
+
+	rc = ddf_fun_bind(nic_data->fun);
+	if (rc != EOK) {
+		ddf_fun_destroy(nic_data->fun);
+		return rc;
+	}
+
+	rc = ddf_fun_add_to_category(nic_data->fun, DEVICE_CATEGORY_NIC);
+	if (rc != EOK) {
+		ddf_fun_destroy(nic_data->fun);
+		return rc;
+	}
+	
+	return EOK;
+}
+
+/**
  * Set information about current HW filtering.
  *  1 ...	Only those frames we want to receive are passed through HW
@@ -986,13 +1097,4 @@
 {
 	return nic_data->fun;
-}
-
-/**
- * @param nic_data
- * @param fun
- */
-void nic_set_ddf_fun(nic_t *nic_data, ddf_fun_t *fun)
-{
-	nic_data->fun = fun;
 }
 
@@ -1227,4 +1329,23 @@
 }
 
+/** Lock packet for DMA usage
+ *
+ * @param packet
+ * @return physical address of packet
+ */
+int nic_dma_lock_packet(packet_t *packet, size_t size, void **phys)
+{
+	return dmamem_map(packet, SIZE2PAGES(size), 0, 0, phys);
+}
+
+/** Unlock packet after DMA usage
+ *
+ * @param packet
+ */
+int nic_dma_unlock_packet(packet_t *packet, size_t size)
+{
+	return dmamem_unmap(packet, size);
+}
+
 /** @}
  */
Index: uspace/lib/nic/src/nic_impl.c
===================================================================
--- uspace/lib/nic/src/nic_impl.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/nic/src/nic_impl.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -36,10 +36,8 @@
  */
 
-#include <errno.h>
 #include <str_error.h>
 #include <ipc/services.h>
 #include <ns.h>
 #include "nic_driver.h"
-#include "nic_ev.h"
 #include "nic_impl.h"
 
@@ -87,5 +85,6 @@
 	}
 	if (state == NIC_STATE_ACTIVE) {
-		if (nic_data->client_session == NULL) {
+		if (nic_data->nil_session == NULL || nic_data->net_session == NULL
+		    || nic_data->device_id < 0) {
 			fibril_rwlock_write_unlock(&nic_data->main_lock);
 			return EINVAL;
@@ -117,6 +116,6 @@
 	if (state == NIC_STATE_STOPPED) {
 		/* Notify upper layers that we are reseting the MAC */
-		int rc = nic_ev_addr_changed(nic_data->client_session,
-			&nic_data->default_mac);
+		int rc = nil_addr_changed_msg(nic_data->nil_session,
+			nic_data->device_id, &nic_data->default_mac);
 		nic_data->poll_mode = nic_data->default_poll_mode;
 		memcpy(&nic_data->poll_period, &nic_data->default_poll_period,
@@ -150,5 +149,5 @@
 	nic_data->state = state;
 
-	nic_ev_device_state(nic_data->client_session, state);
+	nil_device_state_msg(nic_data->nil_session, nic_data->device_id, state);
 
 	fibril_rwlock_write_unlock(&nic_data->main_lock);
@@ -183,24 +182,31 @@
 
 /**
- * Default implementation of the connect_client method.
- * Creates callback connection to the client.
+ * Default implementation of the connect_to_nil method.
+ * Connects the driver to the NIL service.
  *
  * @param	fun
- *
- * @return EOK		On success, or negative error code.
- */
-int nic_callback_create_impl(ddf_fun_t *fun)
-{
-	nic_t *nic = (nic_t *) fun->driver_data;
-	fibril_rwlock_write_lock(&nic->main_lock);
+ * @param	nil_service	ID of the server implementing the NIL service
+ * @param	device_id	ID of the device as used in higher layers
+ *
+ * @return EOK		If the services were bound
+ * @return 			Negative error code from service_connect_blocking
+ */
+int nic_connect_to_nil_impl(ddf_fun_t *fun, services_t nil_service,
+    nic_device_id_t device_id)
+{
+	nic_t *nic_data = (nic_t *) fun->driver_data;
+	fibril_rwlock_write_lock(&nic_data->main_lock);
 	
-	nic->client_session = async_callback_receive(EXCHANGE_SERIALIZE);
-	if (nic->client_session == NULL) {
-		fibril_rwlock_write_unlock(&nic->main_lock);
-		return ENOMEM;
-	}
+	nic_data->device_id = device_id;
 	
-	fibril_rwlock_write_unlock(&nic->main_lock);
-	return EOK;
+	nic_data->nil_session = service_connect_blocking(EXCHANGE_SERIALIZE,
+	    nil_service, 0, 0);
+	if (nic_data->nil_session != NULL) {
+		fibril_rwlock_write_unlock(&nic_data->main_lock);
+		return EOK;
+	}
+	
+	fibril_rwlock_write_unlock(&nic_data->main_lock);
+	return EHANGUP;
 }
 
@@ -799,4 +805,16 @@
 }
 
+/** Default implementation of the device_added method
+ *
+ * Just calls nic_ready.
+ *
+ * @param dev
+ *
+ */
+void nic_device_added_impl(ddf_dev_t *dev)
+{
+	nic_ready((nic_t *) dev->driver_data);
+}
+
 /**
  * Default handler for unknown methods (outside of the NIC interface).
Index: uspace/lib/nic/src/nic_rx_control.c
===================================================================
--- uspace/lib/nic/src/nic_rx_control.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/nic/src/nic_rx_control.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -40,6 +40,7 @@
 #include <bool.h>
 #include <errno.h>
-#include <mem.h>
-#include <nic/nic.h>
+#include <net/device.h>
+#include <net_checksum.h>
+#include <packet_client.h>
 #include "nic_rx_control.h"
 
@@ -391,17 +392,14 @@
  *
  * @param rxc
- * @param frame	    The probed frame
+ * @param packet	The probed frame
  *
  * @return True if the frame passes, false if it does not
  */
-int nic_rxc_check(const nic_rxc_t *rxc, const void *data, size_t size,
+int nic_rxc_check(const nic_rxc_t *rxc, const packet_t *packet,
 	nic_frame_type_t *frame_type)
 {
 	assert(frame_type != NULL);
-	uint8_t *dest_addr = (uint8_t *) data;
+	uint8_t *dest_addr = (uint8_t *) packet + packet->data_start;
 	uint8_t *src_addr = dest_addr + ETH_ADDR;
-
-	if (size < 2 * ETH_ADDR)
-		return false;
 
 	if (dest_addr[0] & 1) {
@@ -450,5 +448,5 @@
 	if (!rxc->vlan_exact && rxc->vlan_mask != NULL) {
 		vlan_header_t *vlan_header = (vlan_header_t *)
-			((uint8_t *) data + 2 * ETH_ADDR);
+			((uint8_t *) packet + packet->data_start + 2 * ETH_ADDR);
 		if (vlan_header->tpid_upper == VLAN_TPID_UPPER &&
 			vlan_header->tpid_lower == VLAN_TPID_LOWER) {
@@ -486,43 +484,4 @@
 		rxc->vlan_exact = vlan_exact;
 }
-
-/** Polynomial used in multicast address hashing */
-#define CRC_MCAST_POLYNOMIAL  0x04c11db6
-
-/** Compute the standard hash from MAC
- *
- * Hashing MAC into 64 possible values and using the value as index to
- * 64bit number.
- *
- * The code is copied from qemu-0.13's implementation of ne2000 and rt8139
- * drivers, but according to documentation there it originates in FreeBSD.
- *
- * @param[in] addr The 6-byte MAC address to be hashed
- *
- * @return 64-bit number with only single bit set to 1
- *
- */
-static uint64_t multicast_hash(const uint8_t addr[6])
-{
-	uint32_t crc;
-    int carry, i, j;
-    uint8_t b;
-
-    crc = 0xffffffff;
-    for (i = 0; i < 6; i++) {
-        b = addr[i];
-        for (j = 0; j < 8; j++) {
-            carry = ((crc & 0x80000000L) ? 1 : 0) ^ (b & 0x01);
-            crc <<= 1;
-            b >>= 1;
-            if (carry)
-                crc = ((crc ^ CRC_MCAST_POLYNOMIAL) | carry);
-        }
-    }
-	
-    uint64_t one64 = 1;
-    return one64 << (crc >> 26);
-}
-
 
 /**
